
_G[gTable] = {};

local aTmpVal  = gTable;
local aState   = 0;
local aCurCell = 0;
cm.SetupTable(_G[aTmpVal]);


-- Called on Init
_G[gTable].OnInit = function(pObj)
	pObj.mState = 0;
	aState      = pObj.mState;
	aCurCell    = pObj.mCurCell;
end


-- Called after data being loaded from disk
_G[gTable].OnLoad = function(pObj)
	aState     = pObj.mState;
	aCurCell   = pObj.mCurCell;
end


--Called after level being reloaded
_G[gTable].OnLevelLoad = function(pObj)
	aState   = pObj.mState;
	aCurCell = pObj.mCurCell;
end

-- Called on a update
_G[gTable].OnUpdate = function(pObj)

   if aState == 1 then
      if cm.GetGlobalBoolIndirect(pObj, "PuzzleFlag") then
         pObj:StartFadeRects(PhFadeAnotherTimeLong);
         aState          = aState + 1
         pObj.mState     = aState;
         aCurCell        = aCurCell + 1;
   		pObj.mCurCell   = aCurCell;

   		local aNum = pObj:GetFirstActive(0);
   		pObj:SetActive(0, aNum, false);
   		pObj:SetActive(0, aNum + 1, true);

   		pObj:StopParticleEmission(false);
   		IcPlaySample("PH_SFX_OBJ_USED");
      end
   end
end


-- Called on a succesful click
_G[gTable].OnClick =  function(pObj, pName, pActorObj, pPolyNum, pX, pY)

	pObj.mDiscovered = true;
	if pName == "" then

   	if aState == 2 then

         if not cm.SpawnObject(pObj, 0, pObj.mSmPos, "SpawnObject") then
            return true;
         end

         pObj:StartFadeRects(PhFadeAnotherTimeLong);
         aState          = aState + 1;
   		pObj.mState     = aState;
         aCurCell        = aCurCell + 1;
   		pObj.mCurCell   = aCurCell;
   		cm.DisableObject(pObj);

   		IcPlaySample("PH_SFX_OBJ_PICKUP");
   		return true;

   	elseif aState == 1 then
         cm.LaunchPuzzle(pObj);
         return true;

   	elseif aState == 0 then
         cm.GetShowInfo(pObj, "InfoStr1", "InfoTime1");
         return true;
      end
   	return true;

	elseif pName == pObj.mCsData:GetString("KeyObject1") then

      if aState == 0 then

         pObj:StartFadeRects(PhFadeAnotherTimeLong);
         aState          = aState + 1
         pObj.mState     = aState;
         aCurCell        = aCurCell + 1;
   		pObj.mCurCell   = aCurCell;
   		pObj:SetActive(0, pPolyNum, false);
   		pObj:SetActive(0, pPolyNum + 1, true);

   		pObj:StopParticleEmission(false);
   		_G[pActorObj.mScriptTag].OnUse(pActorObj, pObj);
   		return true;
		else
         cm.GetShowInfo(pObj, "InfoStr2", "InfoTime2");
         IcPlaySample("PH_SFX_DOES_NOT_WORK");
      end
      return false;

	else
		cm.ObjDoesNotWork(pObj);
		return false;
	end

	return false;
end



-- Called on draw
_G[gTable].OnDraw =  function(pObj, pG)

	local aRpos = pObj.mSmPos;
	local aImg  = IcImageWrap(pObj.mSmallImage);
	assert(aImg);
	local aRect = aImg:GetCelRect(aCurCell);
	pG:DrawImage(aImg:GetImage(), aRpos.x, aRpos.y, aRect);


end

